import 'dart:convert';
import 'package:flutter/services.dart';

class AppConfig {
  static final AppConfig _instance = AppConfig._internal();
  Map<String, String> _config = {};

  AppConfig._internal();

  factory AppConfig() => _instance;

  Future<void> loadConfig() async {
    final response = await rootBundle.loadString('assets/config/front.json');
    _config = Map<String, String>.from(json.decode(response));
  }

  String get(String key, {String defaultValue = ''}) {
    return _config[key] ?? defaultValue;
  }
}
