import 'package:flutter/material.dart';
import 'package:oc_front/core/services/router.dart';

class LeftMenuWidget extends StatefulWidget {
  const LeftMenuWidget({Key? key}): super(key: key);
  @override LeftMenuWidgetState createState() => LeftMenuWidgetState();
}

class LeftMenuWidgetState extends State<LeftMenuWidget> {
  @override Widget build(BuildContext context) {
    var routes = AppRouter.zones.where(  (e) => e.label != null && e.icon != null).toList();
    List<Widget> widgets = routes.map( (e) => Opacity(  opacity: AppRouter.currentRoute.route == e.route ?  1 : .5,
      child: Tooltip( message: e.label, child: SizedBox(  width: 50,  height: 50, child: InkWell(
        onTap: () { e.go(context, {}); },
        child: Center( child: Icon(e.icon, color:Colors.white) ),
      ),
    )))).toList();
    return Column( children: widgets);
  }
}