import 'package:oc_front/core/conf/conf_reader.dart';
import 'package:oc_front/models/response.dart';
import 'package:oc_front/core/services/api_service.dart';

class EnumService {
  static var conf = AppConfig();
  static APIService<EnumData>? _service;
  static String subPath = "/enum/";
  static Map<String, Map<String,dynamic>> enums = {};

  static int? get(String path, dynamic name) {
    var n = enums[path];
    if (n == null) {
      return null;
    }
    var names = "$name";
    for (var nn in n.keys) {
      if (n[nn] == names || nn == names) {
        return int.parse(nn);
      }
    }
    return null;
  }

  static void init() {
    _service = _service ?? APIService<EnumData>(
      baseURL: const String.fromEnvironment("HOST", defaultValue: "http://localhost:8000") + conf.get('CATALOG_HOST', 
        defaultValue: '/catalog')
    );
    _load("infrastructure");
    _load("storage/type");
    _load("storage/size");
    _load("resource/type");
    _load("booking/status");
    _load("status");
    _load("pricing/strategy/buy");
    _load("pricing/strategy/data");
    _load("pricing/strategy/time");
    _load("pricing/strategy/storage");
    _load("pricing/strategy/privilege/storage");
    _load("pricing/strategy/privilege");
    _load("pricing/refund/type");
  }

  static void _load(String name) {
    _service!.get("$subPath$name", false, null).then((response) {
      if (response.code == 200) {
        enums[name] = response.data!.value;
      }
    });
  }
}