import 'dart:convert';

import 'package:oc_front/main.dart';

enum Perms { 
  SEARCH_INTERNAL,// ignore: constant_identifier_names
  SEARCH_EXTERNAL, // ignore: constant_identifier_names

  WORKSPACE_SHARE,// ignore: constant_identifier_names
  WORKSPACE_UNSHARE,// ignore: constant_identifier_names

  WORKFLOW_CREATE, // ignore: constant_identifier_names
  WORKFLOW_EDIT, // ignore: constant_identifier_names
  WORKFLOW_DELETE, // ignore: constant_identifier_names
  WORKFLOW_BOOKING, // ignore: constant_identifier_names
  WORKFLOW_SHARE, // ignore: constant_identifier_names
  WORKFLOW_UNSHARE, // ignore: constant_identifier_names

  PEER_SHARE, // ignore: constant_identifier_names
  PEER_UNSHARE, // ignore: constant_identifier_names

  COLLABORATIVE_AREA_CREATE, // ignore: constant_identifier_names
  COLLABORATIVE_AREA_EDIT, // ignore: constant_identifier_names
  COLLABORATIVE_AREA_DELETE, // ignore: constant_identifier_names
}

Map<Perms, String> perms = {
  Perms.SEARCH_INTERNAL: 'GET__CATALOG_COMPUTE_SEARCH_SEARCH'.toUpperCase(),
  Perms.SEARCH_EXTERNAL: 'Search External'.toUpperCase(),
  Perms.WORKSPACE_SHARE: 'POST__SHARED_COLLABORATIVE_AREA_ID_WORKSPACE_ID2'.toUpperCase(),
  Perms.WORKFLOW_CREATE: 'POST__WORKFLOW_'.toUpperCase(),
  Perms.WORKFLOW_UNSHARE: 'DELETE__SHARED_COLLABORATIVE_AREA_ID_WORKFLOW_ID2'.toUpperCase(),
  Perms.PEER_SHARE: 'POST__SHARED_COLLABORATIVE_AREA_ID_PEER_ID2'.toUpperCase(),
  Perms.PEER_UNSHARE: 'DELETE__SHARED_COLLABORATIVE_AREA_ID_PEER_ID2'.toUpperCase(),
  Perms.COLLABORATIVE_AREA_CREATE: 'POST__SHARED_COLLABORATIVE_AREA_'.toUpperCase(),
  Perms.COLLABORATIVE_AREA_EDIT: 'PUT__SHARED_COLLABORATIVE_AREA_ID'.toUpperCase(),
  Perms.COLLABORATIVE_AREA_DELETE: 'DELETE__SHARED_COLLABORATIVE_AREA_ID'.toUpperCase(),
  Perms.WORKSPACE_UNSHARE: 'DELETE__SHARED_COLLABORATIVE_AREA_ID_WORKSPACE_ID2'.toUpperCase(),
  Perms.WORKFLOW_EDIT: 'PUT__WORKFLOW_ID'.toUpperCase(),
  Perms.WORKFLOW_DELETE: 'DELETE__WORKFLOW_ID'.toUpperCase(),
  Perms.WORKFLOW_BOOKING: 'POST__DATACENTER_BOOKING_'.toUpperCase(),
  Perms.WORKFLOW_SHARE: 'POST__SHARED_COLLABORATIVE_AREA_ID_WORKFLOW_ID2'.toUpperCase(),
};

class PermsService {
  static final Map<Perms, bool> _perms = {
    Perms.SEARCH_INTERNAL: false,
    Perms.SEARCH_EXTERNAL: false,
    Perms.WORKSPACE_SHARE: false,
    Perms.WORKSPACE_UNSHARE: false,
    Perms.WORKFLOW_CREATE: false,
    Perms.WORKFLOW_EDIT: false,
    Perms.WORKFLOW_DELETE: false,
    Perms.WORKFLOW_BOOKING: false,
    Perms.WORKFLOW_SHARE: false,
    Perms.WORKFLOW_UNSHARE: false,
    Perms.PEER_SHARE: false,
    Perms.PEER_UNSHARE: false,
    Perms.COLLABORATIVE_AREA_CREATE: false,
    Perms.COLLABORATIVE_AREA_EDIT: false,
    Perms.COLLABORATIVE_AREA_DELETE: false,
  };
  static final PermsService _instance = PermsService._internal();
  factory PermsService() => _instance;
  PermsService._internal();
  /* should decode claims such as in oc-auth */
  static Future<void> init(String token ) async {
    var claims = token.split(".").last;
    var decoded = base64.decode(claims);
    String foo = utf8.decode(decoded);
    try {
      var what = json.decode(foo);
      what = what["session"]["access_token"] as Map<String, dynamic>;
      for (var w in perms.keys) {
        if (what.keys.contains(perms[w])) {
          _perms[w] = true;
        } else {
          _perms[w] = false;
        }
      }
      mainKey?.currentState?.setState(() {});
    } catch (e) {/**/}
  }

  static void clear() {
    _perms.forEach((key, value) {
      _perms[key] = false;
    });
  }
  static bool getPerm(Perms perm) {
    return _perms[perm] ?? false;
  }

  static void setPerm(Perms perm, bool value) {
    _perms[perm] = value;
  }

}