import 'package:flutter/material.dart';
import 'package:oc_front/core/services/api_service.dart';
import 'package:oc_front/core/services/specialized_services/abstract_service.dart';
import 'package:oc_front/models/response.dart';
import 'package:oc_front/models/workflow.dart';

class BookingExecutionService extends AbstractService<WorkflowExecution> {
  @override late final APIService<WorkflowExecution> service;

  BookingExecutionService() {
    service = APIService<WorkflowExecution>(
        baseURL: const String.fromEnvironment("HOST", defaultValue: "http://localhost:8000") + super.conf.get('BOOKING_HOST',
            defaultValue: '/booking'));
  }
  @override String subPath = "/booking/";

  @override Future<APIResponse<WorkflowExecution>> search(BuildContext? context, List<String> words, Map<String, dynamic> params) {  
    return service.get("${subPath}search/${words.join("/")}", false, context);
  }

  @override Future<APIResponse<WorkflowExecution>> post(BuildContext? context, Map<String, dynamic> body, Map<String, String> params) { 
    return throw UnimplementedError();
  }
  @override Future<APIResponse<WorkflowExecution>> put(BuildContext? context, String id, Map<String, dynamic> body, Map<String, String> params) { 
    return throw UnimplementedError();
  }
}
