import 'package:flutter/material.dart';
import 'package:oc_front/core/services/api_service.dart';
import 'package:oc_front/core/services/specialized_services/abstract_service.dart';
import 'package:oc_front/models/logs.dart';
import 'package:oc_front/models/response.dart';

class LogsService extends AbstractService<LogsResult> {
  @override
  late final APIService<LogsResult> service;

  @override
  String subPath = "/loki";

  LogsService() {
    service = APIService<LogsResult>(
        baseURL: const String.fromEnvironment("HOST", defaultValue: "http://localhost:8000") + super.conf.get('SCHEDULER_HOST', defaultValue: '/scheduler'));
  }

  @override
  Future<APIResponse<LogsResult>> search(BuildContext? context, List<String> words, Map<String, dynamic> params) {
    return service.post(subPath, params, context);
  }

  @override
  Future<APIResponse<LogsResult>> get(BuildContext? context, String id) {
    throw UnimplementedError();
  }

  @override
  Future<APIResponse<LogsResult>> post(BuildContext? context,
      Map<String, dynamic> body, Map<String, String> params) {
    throw UnimplementedError();
  }

  @override
  Future<APIResponse<LogsResult>> put(BuildContext? context, String id,
      Map<String, dynamic> body, Map<String, String> params) {
    throw UnimplementedError();
  }

  @override
  Future<APIResponse<LogsResult>> delete(
      BuildContext? context, String id, Map<String, String> params) {
    throw UnimplementedError();
  }
}
