import 'package:flutter/material.dart';
import 'package:oc_front/core/services/api_service.dart';
import 'package:oc_front/core/services/specialized_services/abstract_service.dart';
import 'package:oc_front/models/response.dart';
import 'package:oc_front/models/shared.dart';

class SharedService extends AbstractService<CollaborativeArea> {
  @override
  late final APIService<CollaborativeArea> service;

  @override
  String subPath = "/collaborative_area/";

  SharedService() {
    service = APIService<CollaborativeArea>(
        baseURL: const String.fromEnvironment("HOST", defaultValue: "http://localhost:8000") + super.conf.get('COLLABORATIVE_AREA_HOST',
            defaultValue: '/shared'));
  }

  Future<APIResponse<CollaborativeArea>> addWorkspace(
      BuildContext? context, String id, String id2) {
    return service.post("$subPath$id/workspace/$id2", {}, context);
  }

  Future<APIResponse<CollaborativeArea>> addWorkflow(
      BuildContext? context, String id, String id2) {
    return service.post("$subPath$id/workflow/$id2", {}, context);
  }

  Future<APIResponse<CollaborativeArea>> addPeer(
      BuildContext? context, String id, String id2) {
    return service.post("$subPath$id/peer/$id2", {}, context);
  }

  Future<APIResponse<CollaborativeArea>> removeWorkspace(
      BuildContext? context, String id, String id2) {
    return service.delete("$subPath$id/workspace/$id2", context);
  }

  Future<APIResponse<CollaborativeArea>> removeWorkflow(
      BuildContext? context, String id, String id2) {
    return service.delete("$subPath$id/workflow/$id2", context);
  }

  Future<APIResponse<CollaborativeArea>> removePeer(
      BuildContext? context, String id, String id2) {
    return service.delete("$subPath$id/peer/$id2", context);
  }
}
