import 'package:flutter/material.dart';
import 'package:oc_front/core/services/api_service.dart';
import 'package:oc_front/core/services/specialized_services/abstract_service.dart';
import 'package:oc_front/models/response.dart';
import 'package:oc_front/models/workflow.dart';

class SchedulerService extends AbstractService<WorkflowExecutions> {
  @override late final APIService<WorkflowExecutions> service;

  SchedulerService() {
    service = APIService<WorkflowExecutions>(
        baseURL: const String.fromEnvironment("HOST", defaultValue: "http://localhost:8000") + super.conf.get('SCHEDULER_HOST',
            defaultValue: '/scheduler'));
  }
  @override String subPath = "/";

  Future<APIResponse<WorkflowExecutions>> schedule(BuildContext? context, String id, Map<String, dynamic> body, Map<String, dynamic> params) {  
    return service.post("$subPath$id", body, context);
  }

  @override Future<APIResponse<WorkflowExecutions>> search(BuildContext? context, List<String> words, Map<String, dynamic> params) {  
    return throw UnimplementedError();
  }

  @override Future<APIResponse<WorkflowExecutions>> post(BuildContext? context, Map<String, dynamic> body, Map<String, String> params) { 
    return throw UnimplementedError();
  }
  @override Future<APIResponse<WorkflowExecutions>> put(BuildContext? context, String id, Map<String, dynamic> body, Map<String, String> params) { 
    return throw UnimplementedError();
  }
}