import 'package:flutter/material.dart';
import 'package:flutter_flow_chart/flutter_flow_chart.dart';
import 'package:oc_front/models/resources/resources.dart';
import 'package:oc_front/widgets/inputs/sub_text_input.dart';

// ignore: must_be_immutable
class CredentialsFormsWidget extends StatefulWidget {
  int instanceID = 0;
  Dashboard dash;
  AbstractItem item;
  String elementID;
  CredentialsFormsWidget({ super.key, required this.item, required this.dash, required this.elementID });
  @override CredentialsFormsWidgetState createState() => CredentialsFormsWidgetState();
}

class CredentialsFormsWidgetState extends State<CredentialsFormsWidget> {
  @override Widget build(BuildContext context) {
    List<Widget> widgets = [];
    var instance = widget.item.getSelectedInstance();
    if (instance != null  && instance.credential != null) {
      var creds = instance.credential!;
      widgets.add(Container( margin: const EdgeInsets.only(bottom: 15),
        width: 200, decoration: const BoxDecoration( border: Border(bottom: BorderSide(color: Colors.grey))),
      ));
      widgets.add(Container(
        padding: const EdgeInsets.only(bottom: 10),
        width: 180,
        child: Column( 
          mainAxisAlignment: MainAxisAlignment.center,
          children: [
            const Text("<CREDENTIALS>", style: TextStyle(fontSize: 13, fontWeight: FontWeight.bold), textAlign: TextAlign.center),
            SubTextInputWidget(subkey: "login", width: 180, empty: false, change: (value) {
              creds.login = value;
                for (var el in widget.dash.elements) {
                    if (el.id == widget.elementID) {
                      el.element = widget.item;
                      break;
                    }
                }
                widget.dash.saveDash(widget.dash.id, context);
            },  initialValue: creds.login),
            SubTextInputWidget(subkey: "password", width: 180, empty: false, change: (value) {
                creds.password = value;
                for (var el in widget.dash.elements) {
                    if (el.id == widget.elementID) {
                      el.element = widget.item;
                      break;
                    }
                }
                widget.dash.saveDash(widget.dash.id, context);
              }, initialValue: creds.password, readOnly: false,),
          ],)
        ));
        widgets.add(Container( padding: EdgeInsets.only(bottom: 15), width: 200 ));
    }
    return Column(children: widgets);
  }
}