
import 'package:flutter/material.dart';
import 'package:flutter_flow_chart/flutter_flow_chart.dart';
import 'package:oc_front/models/resources/resources.dart';
import 'package:oc_front/widgets/forms/sub_keys_forms.dart';
import 'package:oc_front/widgets/inputs/sub_text_input.dart';

// ignore: must_be_immutable
class SubAddFormsWidget extends StatefulWidget {
  bool readOnly;
  SubMapFormsType type;
  String elementID = "";
  AbstractItem item;
  Dashboard dash; 
  bool empty = false;
  List<Param> forms = [];
  SubAddFormsWidget ({ super.key, required this.dash, this.readOnly = false,
    this.empty = false, required this.item, required this.elementID,
    required this.type });
  @override SubAddFormsWidgetState createState() => SubAddFormsWidgetState();
}
class SubAddFormsWidgetState extends State<SubAddFormsWidget> {
  Param? addedparam;
  @override Widget build(BuildContext context) {
    AbstractInstance instance = widget.item.getSelectedInstance()!;
    var f = (widget.type == SubMapFormsType.INPUT ? instance.inputs : ( 
      widget.type == SubMapFormsType.OUTPUT ? instance.outputs : instance.env)).where( (e) => !e.readOnly).toList();
    widget.forms = f;
    if (addedparam != null) {
      widget.forms.add(addedparam!);
    }
    List<Widget> children = [];
    for (var param in widget.forms) {
      children.add(Row( mainAxisAlignment: MainAxisAlignment.center, children: [
        SubTextInputWidget(subkey: "key", readOnly: widget.readOnly,
          initialValue: param.name, width: 81, empty: widget.empty, 
          change: (value) { 
            setState(() {
              param.name = value;
              param.attr = value;
              if (addedparam?.value != null && addedparam?.name != null) {
                addedparam = null;
              }
              var sel = widget.item.getSelectedInstance();
              if (sel != null) {
                if (widget.type == SubMapFormsType.INPUT) { sel.inputs = [ 
                    ...sel.inputs.where( (e) => e.readOnly),
                    ...widget.forms.where((e) => e.name != null && e.value != null)
                  ];
                } else if (widget.type == SubMapFormsType.OUTPUT) {  
                  sel.outputs = [
                    ...sel.outputs.where( (e) => e.readOnly),
                    ...widget.forms.where((e) => e.name != null && e.value != null)
                  ];
                } else { 
                  sel.env = [
                    ...sel.env.where( (e) => e.readOnly),
                    ...widget.forms.where((e) => e.name != null && e.value != null)
                  ]; 
                }
            }
            Future.delayed(const Duration(milliseconds: 100), () {
              if (param.name == value) {
                widget.dash.saveDash(widget.dash.id, context);
              }
            });
            var el = widget.dash.getElement(widget.elementID);
            el!.element = widget.item as dynamic;
            setState(() {});
          });
        }),
        const Padding(padding: EdgeInsets.only(left: 5, right: 5, top: 15), child: Text("=", textAlign: TextAlign.center,)),
        SubTextInputWidget(subkey: "value", initialValue: param.value, width: 81, empty: widget.empty, 
          readOnly: widget.readOnly, change: (value) { 
            param.value = value;
            if (addedparam?.value != null && addedparam?.name != null) {
              addedparam = null;
            }
            var sel = widget.item.getSelectedInstance();
            if (sel != null) {
                if (widget.type == SubMapFormsType.INPUT) { sel.inputs = [ 
                    ...sel.inputs.where( (e) => e.readOnly),
                    ...widget.forms.where((e) => e.name != null && e.value != null)
                  ];
                } else if (widget.type == SubMapFormsType.OUTPUT) {  
                  sel.outputs = [
                    ...sel.outputs.where( (e) => e.readOnly),
                    ...widget.forms.where((e) => e.name != null && e.value != null)
                  ];
                } else { 
                  sel.env = [
                    ...sel.env.where( (e) => e.readOnly ),
                    ...widget.forms.where((e) => e.name != null && e.value != null)
                  ]; 
                }
            }
            var el = widget.dash.getElement(widget.elementID);
            el!.element = widget.item as dynamic;
            setState(() {});
            Future.delayed(const Duration(milliseconds: 100), () {
              if (param.value == value) {
                widget.dash.saveDash(widget.dash.id, context);
              }
            });
        }),     
      ]));
    }
    return Column( crossAxisAlignment: CrossAxisAlignment.center, children : [
      widget.readOnly ? Container() : Row( mainAxisAlignment: MainAxisAlignment.center, children: [
              InkWell( onTap: () {
                  if (widget.forms.isNotEmpty && (widget.forms[widget.forms.length - 1].name == null
                  || widget.forms[widget.forms.length - 1].value == null)) { return;}
                  widget.forms.add(Param(readOnly: false));
                  addedparam = widget.forms.last;
                  var el = widget.dash.getElement(widget.elementID);
                  el!.element = widget.item as dynamic;
                  setState(() {});
                }, child: Container( margin: const EdgeInsets.only(top: 10),
                    decoration: BoxDecoration(borderRadius: BorderRadius.circular(5), 
                    border: Border.all(color: widget.forms.isNotEmpty && (widget.forms[widget.forms.length - 1].name == null
                  || widget.forms[widget.forms.length - 1].value == null) ? Colors.grey : Colors.grey, width: 1)),
                    width: 125, height: 30,
                    child: Row( mainAxisAlignment: MainAxisAlignment.center,
                      children: [ Padding( padding: EdgeInsets.only(right: 5), child: Icon(Icons.add, color: widget.forms.isNotEmpty && (widget.forms[widget.forms.length - 1].name == null
                  || widget.forms[widget.forms.length - 1].value == null) ? Colors.grey : Colors.black,)), 
                      Text(widget.type == SubMapFormsType.ENV ? "env" : (widget.type == SubMapFormsType.INPUT ? "input" : "output"),
                        style: TextStyle( color: widget.forms.isNotEmpty && (widget.forms[widget.forms.length - 1].name == null
                  || widget.forms[widget.forms.length - 1].value == null) ? Colors.grey : Colors.black))]),
                  ),  
              ),
              InkWell( onTap: () {
                      if (addedparam != null) {
                        addedparam = null;
                        return setState(() {});
                      }
                      if (widget.forms.isEmpty) { return; }
                      widget.forms.sublist(0, widget.forms.length - 1);
                      var el = widget.dash.getElement(widget.elementID);
                      var sel = widget.item.getSelectedInstance();
                      if (sel != null) {
                          widget.forms.removeLast();
                          if (widget.type == SubMapFormsType.INPUT) { sel.inputs = [ 
                              ...sel.inputs.where( (e) => e.readOnly),
                              ...widget.forms.where((e) => e.name != null && e.value != null)
                            ];
                          } else if (widget.type == SubMapFormsType.OUTPUT) {  
                            sel.outputs = [
                              ...sel.outputs.where( (e) => e.readOnly),
                              ...widget.forms.where((e) => e.name != null && e.value != null)
                            ];
                          } else { 
                            sel.env = [
                              ...sel.env.where( (e) => e.readOnly),
                              ...widget.forms.where((e) => e.name != null && e.value != null)
                            ]; 
                          }
                      }
                      el!.element = widget.item as dynamic;
                      setState(() { widget.dash.saveDash(widget.dash.id, context); });
                    }, child:
                    Container( margin: const EdgeInsets.only(left: 5, top: 10),
                      decoration: BoxDecoration(borderRadius: BorderRadius.circular(5), 
                        border: Border.all(color: widget.forms.isEmpty ? Colors.grey : Colors.black , width: 1)),
                      width: 50, height: 30,
                      child: Row( mainAxisAlignment: MainAxisAlignment.center,
                        children: [ Icon( Icons.delete, size: 18,
                          color: widget.forms.isEmpty ? Colors.grey : Colors.black ) ]),
                    )
                  ), 
            ]),
      ...children
    ]); 
  }
}