
import 'package:flutter/material.dart';
import 'package:oc_front/models/resources/processing.dart';
import 'package:flutter_flow_chart/flutter_flow_chart.dart';
import 'package:oc_front/widgets/inputs/sub_text_input.dart';

// ignore: must_be_immutable
class SubExposeFormsWidget extends StatefulWidget {
  bool readOnly;
  Expose item;
  Dashboard dash; 
  String elementID = "";
  double width = 180;
  bool empty = false;
  SubExposeFormsWidget ({ super.key, required this.dash, this.readOnly = false,
    this.empty = false, required this.item, required this.elementID, required this.width });
  @override SubExposeFormsWidgetState createState() => SubExposeFormsWidgetState();
}
class SubExposeFormsWidgetState extends State<SubExposeFormsWidget> {
  @override Widget build(BuildContext context) {
    print("qsfqs");
    try {
      var w = SubTextInputWidget(subkey: "reference port", readOnly: widget.readOnly,
        initialValue: widget.item.port != null ? '${widget.item.port}' : null, 
        width: widget.width, 
        empty: widget.empty, 
        change: (value) { 
                  try {
                    widget.item.port = int.parse(value);
                    Future.delayed(const Duration(seconds: 2), () {
                      if (widget.item.port == int.parse(value) && int.parse(value) != 0) {
                        widget.dash.saveDash(widget.dash.id, context);
                      }
                    });
                  } catch (e) {  widget.item.port = null; }
                  var el = widget.dash.getElement(widget.elementID);
                  el!.element = widget.item as dynamic;
                });
    } catch (e,s) {
      print(e);
      print(s);
    }
    return Column( children : [
      Container( margin: const EdgeInsets.only(left: 10, right: 10, top: 15),
                  decoration: const BoxDecoration(border: Border( top: BorderSide(color: Colors.grey, width: 1))),
                  width: 180
        ),
        SubTextInputWidget(subkey: "reference port", readOnly: widget.readOnly,
        initialValue: widget.item.port != null ? '${widget.item.port}' : null, 
        width: 180, 
        empty: widget.empty, 
        change: (value) { 
                  try {
                    widget.item.port = int.parse(value);
                    Future.delayed(const Duration(seconds: 2), () {
                      if (widget.item.port == int.parse(value) && int.parse(value) != 0) {
                        widget.dash.saveDash(widget.dash.id, context);
                      }
                    });
                  } catch (e) {  widget.item.port = null; }
                  var el = widget.dash.getElement(widget.elementID);
                  el!.element = widget.item as dynamic;
                }),
        SubTextInputWidget(
        readOnly: widget.readOnly,
        subkey: "PAT", initialValue: widget.item.PAT != null ? '${widget.item.PAT}' : null, 
        width: widget.width, empty: widget.empty, change: (value) { 
                  try {
                    widget.item.PAT = int.parse(value);
                    Future.delayed(const Duration(seconds: 2), () {
                      if (widget.item.PAT == int.parse(value) && int.parse(value) != 0) {
                        widget.dash.saveDash(widget.dash.id, context);
                      }
                    });
                  } catch (e) { widget.item.PAT = null;  }
                  var el = widget.dash.getElement(widget.elementID);
                  el!.element = widget.item as dynamic;
                }),
        SubTextInputWidget(subkey: "reverse path", initialValue: widget.item.PAT != null ? '${widget.item.PAT}' : null, 
        readOnly: widget.readOnly,
        width: widget.width, empty: widget.empty, change: (value) { 
                  try {
                    widget.item.path = value;
                    Future.delayed(const Duration(seconds: 2), () {
                      if (widget.item.path == value) {  widget.dash.saveDash(widget.dash.id, context); }
                    });
                  } catch (e) { widget.item.path = null;  }
                  var el = widget.dash.getElement(widget.elementID);
                  el!.element = widget.item as dynamic;
                }),
    ]); 
  }
}