import 'package:flutter/material.dart';

/// The arrow tip.
class HandlerWidget extends StatelessWidget {
  ///
  HandlerWidget({
    required this.width,
    required this.height,
    super.key,
    this.backgroundColor = Colors.white,
    this.borderColor = const Color.fromRGBO(38, 166, 154, 1),
    this.icon,
    this.isRadius = false,
  });

  ///
  final double width;

  ///
  final double height;

  ///
  final Color backgroundColor;

  ///
  final Color borderColor;

  ///
  final Widget? icon;

  bool isRadius = false;

  @override
  Widget build(BuildContext context) {
    return Container(
      width: width,
      height: height,
      decoration: BoxDecoration(
        color: backgroundColor,
        borderRadius: BorderRadius.all(
          Radius.circular(isRadius ? 0 : width),
        ),
        border: Border.all(
          width: 2,
          color: borderColor,
          style: BorderStyle.solid,
        ),
      ),
      child: Padding(
        padding: const EdgeInsets.all(4),
        child: FittedBox(child: icon),
      ),
    );
  }
}
